#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    //ENVIRONMENT
    ofBackground(0);
    
    //VARIABLES
    img.loadImage("image.jpg");
    //same as: posX=0; posY=0;
    posX= posY=0;
    scale=0.5;
    width=img.width*scale;
    height=img.height*scale;
    
    img.setImageType(OF_IMAGE_COLOR);
    imgPixels=img.getPixels();
    
    copiedImg.allocate(img.width, img.height, GL_RGB);
    copiedPixels=img.getPixels();
    
}

//--------------------------------------------------------------
void ofApp::update(){
    //manipulate copiedPixels-array
    for (int i=0; i<img.width; i++) {
        for (int j=0; j<img.height; j++) {
            //if Red value is highest
            if (copiedPixels[(i+j*img.width)*3]>copiedPixels[(i+j*img.width)*3+1] && copiedPixels[(i+j*img.width)*3]>copiedPixels[(i+j*img.width)*3+2]) {
                copiedPixels[(i+j*img.width)*3]=255; //R value
                copiedPixels[(i+j*img.width)*3+1]=0; //G value
                copiedPixels[(i+j*img.width)*3+2]=0; //B value
            } //if Green value is highest
            else if(copiedPixels[(i+j*img.width)*3+1]>copiedPixels[(i+j*img.width)*3] && copiedPixels[(i+j*img.width)*3+1]>copiedPixels[(i+j*img.width)*3+2]){
                copiedPixels[(i+j*img.width)*3]=0; //R value
                copiedPixels[(i+j*img.width)*3+1]=255; //G value
                copiedPixels[(i+j*img.width)*3+2]=0; //B value
            }//if Blue value is highest
            else if(copiedPixels[(i+j*img.width)*3+2]>copiedPixels[(i+j*img.width)*3] && copiedPixels[(i+j*img.width)*3+2]>copiedPixels[(i+j*img.width)*3+1]){
                copiedPixels[(i+j*img.width)*3]=0; //R value
                copiedPixels[(i+j*img.width)*3+1]=255; //G value
                copiedPixels[(i+j*img.width)*3+2]=0; //B value
            }
            //meaning if they are all equal
            else {
                copiedPixels[(i+j*img.width)*3]=0; //R value
                copiedPixels[(i+j*img.width)*3+1]=0; //G value
                copiedPixels[(i+j*img.width)*3+2]=0; //B value
            }
        }
    }
    //load copiedPixels-array to copiedImg-texture
    copiedImg.loadData(copiedPixels, img.width, img.height, GL_RGB);
}

//--------------------------------------------------------------
void ofApp::draw(){
    img.draw(posX, posY, width, height);
    copiedImg.draw(posX, posY+height, width, height);
}

//--------------------------------------------------------------
void ofApp::exit(){
    
}

//--------------------------------------------------------------
void ofApp::touchDown(ofTouchEventArgs & touch){
    if (touch.id==0) {
        distX=touch.x-posX;
        distY=touch.y-posY;
    }
}

//--------------------------------------------------------------
void ofApp::touchMoved(ofTouchEventArgs & touch){
    if (touch.id==0) {
        //move image relative to  finger
        float right=posX+width;
        float bottom=posY+height;
        if (touch.x>posX && touch.x<right && touch.y>posY && touch.y<bottom) {
            posX=touch.x-distX;
            posY=touch.y-distY;
        }
    }
    if(touch.id==1){
        //scale the image
        scale=ofDist(touch.x, touch.y, posX, posY)/100;
        width=img.width*scale;
        height=img.height*scale;
        printf("scale %f \n", scale);
    }
}

//--------------------------------------------------------------
void ofApp::touchUp(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::touchDoubleTap(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::touchCancelled(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::lostFocus(){
    
}

//--------------------------------------------------------------
void ofApp::gotFocus(){
    
}

//--------------------------------------------------------------
void ofApp::gotMemoryWarning(){
    
}

//--------------------------------------------------------------
void ofApp::deviceOrientationChanged(int newOrientation){
    
}
